' mypeekenhancer.bas  by NGUYEN.Chung (2012)
' compile with: fbc -dll myplugin.bas
'
' plugin example for midipiano_chung
'
#Include Once "windows.bi"
#Define  noguijpeg  'if you use it add jpeg.dll in the main host exe dir
#Include "gui_chung.bi"


Dim Shared As Integer quit=0,i
Dim Shared As Single vol,gain,auxvar
Dim Shared As Integer mypeek=1,peekenhancer,rate
Sub setpeek()
	mypeek=max2(mypeek,100)
	gain=10^(vol/20)
	rate=max2(10,min2(200,rate))
End Sub
Sub subquit()
	quit=1
End Sub
Dim Shared As String textvol(100),texvol,textpeek(100),texpeek
Dim Shared As String textrate(100),texrate
For i=0 To 20
	textvol(i)=Str(10-i)
Next
For i=0 To 49
	textpeek(i)=Str(100000-i*2000)
Next
For i=1 To 5
	textpeek(i+49)=Str(2000-i*200)
Next
For i=1 To 9
	textpeek(i+54)=Str(1000-i*100)
Next
For i=0 To 38
	textrate(i)=Str(200-i*5)
Next
Sub subvol()
	texvol=getcombotext("win.vol",textvol())
	vol=Val(texvol)
	gain=10^(vol/20)
setpeek()
End Sub
Sub subpeek()
	texpeek=getcombotext("win.peek",textpeek())
	mypeek=Val(texpeek)
setpeek()
End Sub
Sub subrate()
	texrate=getcombotext("win.rate",textrate())
	rate=Val(texrate)
setpeek()
End Sub
Sub subpeekenhancer()
	If peekenhancer=1 Then 
		peekenhancer=0:unsetcheckbox("win.peekenhancer")
	Else 
		peekenhancer=1:setcheckbox("win.peekenhancer")
	EndIf
setpeek()
End Sub
Dim Shared As String ficin,curdir1,windowname
dim Shared As String ficini:ficini="peekenhancer.ini"
Dim Shared As Integer File,winx,winy,wx,wy,depth,windx,windy
Function plugininit Cdecl Alias "plugininit" () As Integer Export
Dim As ZString*255 dllname
GetModuleFileName(guihinstance, dllname, 250)
curdir1=Left(dllname,InStrRev(dllname,"\")-1)
ficini=CurDir1+"/peekenhancer.ini" 
vol=1
If FileExists(ficini)=0 Then Return 1
file=FreeFile
Open ficini For Input As #file
winx=200:winy=100
If Not Eof(file) Then Line Input #file,ficin:winx=Val(ficin)
If Not Eof(file) Then Line Input #file,ficin:winy=Val(ficin)
vol=0
If Not Eof(file) Then Line Input #file,ficin:vol=Val(ficin)
mypeek=32000
If Not Eof(file) Then Line Input #file,ficin:mypeek=Val(ficin)
peekenhancer=0
If Not Eof(file) Then Line Input #file,ficin:peekenhancer=Val(ficin)
rate=100
If Not Eof(file) Then Line Input #file,ficin:rate=Val(ficin)
Close #file
setpeek()
Return 0
End Function 
Function pluginmain Cdecl Alias "pluginmain" () As Integer Export
	windowname=Mid(curdir1,InStrRev(curdir1,"\")+1)+"/peekenhancer.dll"
	'guinotice curdir1
	guireset()
	guibackgroundcolor(250,200,0)
   ScreenInfo wx,wy,depth
	If winx<0 Then winx=0
	If winx>(wx-300) Then winx=wx-300
	If winy<0 Then winy=0
	If winy>(wy-150) Then winy=wy-150
   button("win.quit","quit",@subquit,20,70,50,30)
   statictext("win.tvol","gain(db)",20,4,60,16)
   combobox("win.vol",@subvol,20,23,60,300)
   statictext("win.tpeek","peek",100,4,60,16)
   combobox("win.peek",@subpeek,100,23,80,300)
   statictext("win.trate","rate%",200,4,60,16)
   combobox("win.rate",@subrate,200,23,60,300)
   checkbox("win.peekenhancer","peekenhancer",@subpeekenhancer,120,75,120,20)
   statictext("win.msg","",120,100,140,16)
   openwindow("win",windowname,winx,winy,300,150)
   
   trapclose("win",@subquit)
   reloadcombo("win.vol",textvol())
   texvol=Str(Int(vol))
   selectcombotext("win.vol",texvol,textvol())
   reloadcombo("win.peek",textpeek())
   texpeek=Str(Int(mypeek))
   selectcombotext("win.peek",texpeek,textpeek())
   reloadcombo("win.rate",textrate())
   texrate=Str(Int(rate))
   selectcombotext("win.rate",texrate,textrate())
   If peekenhancer=1 Then setcheckbox("win.peekenhancer")
   guisetfocus("win.vol")
   setpeek()
   
   quit=0
   While guitestkey(vk_escape)=0 And quit=0
   	guiscan
   	Sleep 100
   	If Abs(auxvar)>1e-10 Then printgui("win.msg",Str(auxvar)+"   ")
   Wend
   
   guigetwindowpos("win",winx,winy,windx,windy)
   file=freefile
   Open ficini For Output As #file
   Print #file,winx
   Print #file,winy
   Print #file,vol
   Print #file,mypeek
   Print #file,peekenhancer
   Print #file,rate
   Close #file
   
   'guinotice "plugin"
   guiclose()
	Return 0
End Function
Function pluginclose Cdecl Alias "pluginclose" () As Integer Export
	quit=1
	Return 0
End Function 
Dim Shared As Single kpeek=1,mypeek1=1,xpeek
Dim Shared As Integer tsample
Function pluginproc Cdecl Alias "pluginproc" (ByVal sample As single) As Single Export
	If peekenhancer=0 Then Return gain*sample
	If Abs(sample)>mypeek1 Then
		mypeek1=Abs(sample)
	EndIf
	tsample+=1
	If tsample>1000 Then
		tsample=0
		kpeek=mypeek/mypeek1
		If mypeek1>1 Then mypeek1*=0.9
	EndIf
	xpeek=kpeek*sample
   Return (gain/kpeek)*(xpeek+(rate/100.0)*(Int(xpeek)-xpeek))
End Function 


Dim Shared As Any Ptr hsubplugin
Sub subplugin()
pluginmain()
hsubplugin=0
End Sub
Dim Shared As Double tfocus
Function startpluginmain Cdecl Alias "startpluginmain" () As Integer Export 
If hsubplugin=0 Then
	hsubplugin=ThreadCreate(Cast(Any ptr,@subplugin))
  'guinotice "hsubplugin="+Str(hsubplugin)
  tfocus=Timer 
Else 	
  'Dim As HWND hwin
  'ScreenControl(2, Cast(Integer,hwin)) 'get screen handle
  If tfocus>(Timer+99) Then tfocus=Timer
  If Timer>(tfocus+7) Then
  	setforegroundwindow(getguih("win"))'hwin)
  	Sleep 1500
  	tfocus=Timer 
  EndIf
EndIf 
Return 0
End Function 
Function closepluginmain Cdecl Alias "closepluginmain" () As Integer Export 
'guinotice "closepluginmain"
pluginclose()
If hsubplugin<>0 Then
	ThreadWait(hsubplugin)
EndIf
guiclose()
Return 0
End Function 
Function mypluginproc Cdecl Alias "mypluginproc" (ByVal sample As Single Ptr) As Single Export 
Return pluginproc(*sample)
Return 0
End Function 
